/*
 * mxbody.c -- return body of a mail message
 *
 * bugs: may crop message body when continuous with header
 */

#include <unistd.h>
#include <stdio.h>

const int bs = 1<<10;

#define NEXT_CHAR offset++; more--; if(more <= 0) {more = read(0, buf, bs); offset = 0;}

int
main(int argc, char **argv) {
  char buf[bs];
  int offset=0, more=0, alphanum=0;

  NEXT_CHAR;
  while(1) {
    /* beginning of line */
    while((buf[offset] >= 'a' && buf[offset] <= 'z') ||
	(buf[offset] >= 'A' && buf[offset] <= 'Z') ||
	buf[offset] == '-') { alphanum++; NEXT_CHAR; }
    if(alphanum > 0 && buf[offset] == ':' ||
	alphanum == 0 && (buf[offset] == ' ' || buf[offset] == '	')) {
      do { NEXT_CHAR; } while(buf[offset] != '\n');
      NEXT_CHAR; alphanum = 0;
    } else {
      alphanum = 0;
      break;
    }
  }

  /* eat up newlines */
  if(buf[offset] == '\n' || buf[offset] == '\r') { NEXT_CHAR };

  if(write(1, buf + offset, more) < more) return 1;
  while(1) {
    if((more = read(0, buf, bs)) <= 0) return more;
    if(write(1, buf, more) < more) return 1;
  }
  return 0;
}

